老项目迁移AndroidStudio3.0带你踩完所有坑~

版权声明:本文为博主原创文章,未经博主允许不得转载。 https://blog.csdn.net/rrr9805/article/details/78384755

AndroidStudio3.0刚刚发布两天(版本控的我~),便迫不及待的升级了,升级前也明白这次的版本跨度较大,老项目可能存在很多的问题,没成想还是从中午折腾到了晚上十点.不过结果还不错,成功的跑起来了项目. 列出踩过的坑,希望后面要升级的小伙伴遇到类似的问题可以做个参考;


1.升级安装

升级方法:
1. 直接用自带的更新工具
操作步骤: >菜单栏>Help>Check for Updates..(前提网络要绝对的畅通,你懂的)
pasted-AS手动检查更新版本.png


2. 手动的下载新的版本
下载地址https://developer.android.google.cn/studio/archive.html#android-studio-3-0?utm_source=androiddevtools.cn&utm_medium=website (国内可以访问)

升级完成后,打开原有项目,在经过一段时间到indexing后

升级AS后的首次indexing.png

如果你的项目可以运行,OK,恭喜你,接下来的内容,你可以选择忽略,因为你的项目很nice,啥问题没有(我不相信你啥问题都没有~毕竟我踩了这么多的坑);
如果项目存在配置的问题,那么便可能产生如下问题:

2.问题

1.配置了腾讯的资源文件压缩插件导致的异常

我的项目在indexing后出现的第一个问题

首次indexing后AndResGuard问题.png

  Could not GET 'http://oss.jfrog.org/artifactory/oss-snapshot-local/com/tencent/mm/AndResGuard-gradle-plugin/1.2.1/AndResGuard-gradle-plugin-1.2.1.pom'. Received status code 409 from server: Conflict Enable Gradle 'offline mode' and sync project

看到这个异常我的第一反应就是项目中配置了腾讯的资源文件压缩插件,果断移除;

移除步骤:
1. 在项目级别的build.gradle也就是最外层的build.gradle文件中的dependencies节点中,移除

//资源文件混淆压缩
classpath 'com.tencent.mm:AndResGuard-gradle-plugin:1.2.1'



2. 在应用级别的build.gradle的顶部移除

   apply plugin: 'AndResGuard'//资源文件混淆压缩



3. 第二条中提到build.gradle文件中相关的资源压缩配置需要一并的移除;

   andResGuard {
//    mappingFile = file("./resource_mapping.txt")
    mappingFile = null
    // 当你使用v2签名的时候,7zip压缩是无法生效的。
    use7zip = true
    useSign = true
    // 打开这个开关,会keep住所有资源的原始路径,只混淆资源的名字
    keepRoot = true
    whiteList = [
            // for your icon
            "R.drawable.icon",
            // for fabric
            "R.string.com.crashlytics.*",
            // for umeng update
            "R.string.umeng*",
            "R.string.UM*",
            "R.string.tb_*",
            "R.layout.umeng*",
            "R.layout.tb_*",
            //=========↓↓美洽↓↓=========
            "R.layout.mq_*",
            "R.drawable.mq_*",
            "R.style.mq_*",
            "R.string.mq_*",
            "R.color.mq_*",
            //=========↑↑美洽↑↑=========
            //=========↓↓ping++↓↓=========
            "R.layout.*pingpp*",
            "R.drawable.pingpp*",
            "R.drawable.tips_bg.9.png",
            "R.style.*pingpp*",
            "R.string.*pingpp*",
            "R.id.pingpp*",
            "R.color.*pingpp*",
            //=========↑↑ping++↑↑=========
            "R.drawable.umeng*",
            "R.drawable.tb_*",
            "R.anim.umeng*",
            "R.color.umeng*",
            "R.color.tb_*",
            "R.style.*UM*",
            "R.style.umeng*",
            "R.id.umeng*",
            // umeng share for sina
            "R.drawable.sina*",
            // for google-services.json
            "R.string.google_app_id",
            "R.string.gcm_defaultSenderId",
            "R.string.default_web_client_id",
            "R.string.ga_trackingId",
            "R.string.firebase_database_url",
            "R.string.google_api_key",
            "R.string.google_crash_reporting_api_key",
            // umeng share for facebook
            "R.layout.*facebook*",
            "R.id.*facebook*",
            // umeng share for messager
            "R.layout.*messager*",
            "R.id.*messager*",
            // umeng share commond
            "R.id.progress_bar_parent",
            "R.id.webView"
    ]
    compressFilePattern = [
            "*.png",
            "*.jpg",
            "*.jpeg",
            "*.gif",
            "resources.arsc"
    ]
    sevenzip {
        artifact = 'com.tencent.mm:SevenZip:1.2.1'
        //path = "/usr/local/bin/7za"
    }
}

上述操作完后,同步代码,该问题KO;


2.一直卡在Refreshing项目

第一条中的问题解决后,我出现了
提示升级项目.png
这种提示,在正常的流程中,如果不出现第一个问题,会首先出现这个提示,意思是升级现在项目的编译插件,相信之前升级过AS版本的同学在第一次运行新版本的时候见过这个提示,直接点击update按钮就行了.如果不想接着踩坑那么点击Dont’t reminmd me againg for this project按钮就可以了,它代表你还是用之前版本的插件来运行当前项目,也就不会出现后面一大串的问题;

这里直接点击update按钮;
点击之后如果你网络不畅通的话就会一直的

Refreshing项目.png

之所以会这样,是因为
点击该按钮后实际上做了两件事情

  • 在主项目的build.gradle文件中的dependencies节点中更改了

        //原先的插件版本
     classpath 'com.android.tools.build:gradle:2.3.3'
     //更改后的插件版本
     classpath 'com.android.tools.build:gradle:3.0.0'
  • 在项目目录中的gradle > gradle-wrapper.properties文件中的distributionUrl字段更改了

        //原先的插件版本
     distributionUrl=https://services.gradle.org/distributions/gradle-3.3-all.zip
     //更改后的插件版本
     distributionUrl=https://services.gradle.org/distributions/gradle-4.1-all.zip

    这两个文件修改后AS就会去下载https://services.gradle.org/distributions/gradle-4.1-all.zip这个文件,不用点什么奇技淫巧,就等AS下载完吧(基本完不了)

这里给出两种解决方案:
两种解决方案的前提条件是先把该文件下载下来,AS下载的奇慢,那么把https://services.gradle.org/distributions/gradle-4.1-all.zip扔到迅雷中,分分钟下载完成(迅雷功能不止于此~);

  1. 把文件放到本地的Tomcat服务器,或者IIS服务器中,或者免费的七牛云服务中,获取这个文件的下载地址,修改 gradle-wrapper.properties文件中distributionUrl的值为你的下载地址,关闭AS,重新打开(亲测可行);

  2. 找到.gradle文件夹路径:windows一般在 C:\Users\<当前登录用户名>.gradle,
    mac是在:用户/(当前用户目录)/.gradle,解压下载好的文件到该目录中,关闭AS,重新打开(未亲测);


3.修改输出apk的文件名导致的异常
第二条问题解决后,出现了
输出apk异常.png

Cannot set the value of read-only property 'outputFile' for ApkVariantOutputImpl_Decorated{apkData=Main{type=MAIN, fullName=tiger8shopDebug, filters=[]}} of type com.android.build.gradle.internal.api.ApkVariantOutputImpl. Open File

点击Open File定位到应用级别的build.gradle文件中的这个位置

static def releaseTime() {
    return new Date().format("yyyy-MM-dd-HH-mm", TimeZone.getDefault())//包含时分秒
}

static def debugTime() {
//    return new Date().format("yyyy-MM-dd", TimeZone.getDefault())
    return new Date().format("yyyy", TimeZone.getDefault())
}

//=============================上面的代码定义在android节点外,AS3.0版本如果需要输出apk文件名带上时间,上面代码你可以参考下===================================

  //文件输出名增加版本号和时间
    applicationVariants.all { variant ->
        variant.outputs.each { output ->
            def outputFile = output.outputFile
            if (outputFile != null && outputFile.name.endsWith('.apk')) {
                def fileName
                if (outputFile.name.contains("debug")) {//debug版本,使用自己的文件名,方便记忆
                    fileName = "$applicationId _v${defaultConfig.versionName}_${debugTime()}_code${defaultConfig.versionCode}_debug.apk"
                    output.outputFile = new File(outputFile.parent, fileName)//Open File后定位到这个位置,这个配置,识别不出outputFile是啥了
                } else {
                    fileName = "$applicationId _v${defaultConfig.versionName}_code${defaultConfig.versionCode}_${releaseTime()}_${variant.productFlavors[0].name}_release.apk"
                    output.outputFile = new File(outputFile.parent, fileName)
                }
            }
        }
    }

这个是自己之前配置的可以控制AS输出的apk文件的名称,新版本不能这样配置了,看官方的引导可以改成

 //AS3.0版本
    android.applicationVariants.all { variant ->
        variant.outputs.all {
            if (variant.name.endsWith("Debug")) {
                //debug包
                outputFileName = "$applicationId _v${defaultConfig.versionName}_${debugTime()}_code${defaultConfig.versionCode}_debug.apk"
            } else {
                //release包
        outputFileName = "$applicationId _v${defaultConfig.versionName}_code${defaultConfig.versionCode}_${releaseTime()}_release.apk"
            }
        }
    }

效果和之前差不多,直接更改,问题KO


4.之前项目中配置了第三方APT插件导致的异常

apt导致的异常.png

如上图这个异常是我折腾最长时间的问题,各种百度,Google最终得知和新版本AS3.0中自带了APT处理插件有关,因为自己之前配置的第三方的APT插件,所有它们冲突了~,那么移除则异常KO;

移除步骤
1. 在项目级别的build.gradle也就是最外层的build.gradle文件中的dependencies节点中,移除

        classpath 'com.neenbedankt.gradle.plugins:android-apt:1.8'



2. 在应用级别的build.gradle的顶部移除

    apply plugin: 'android-apt'



3. 在应用级别的build.gradle的dependencies节点中,替换所有用apt开头的引依赖为annotationProcessor例如

    //替换之前
    apt "com.jakewharton:butterknife-compiler:$rootProject.ext.globalButterKnifeAptVersion"
    //替换之后
    annotationProcessor "com.jakewharton:butterknife-compiler:$rootProject.ext.globalButterKnifeAptVersion"

上面三步操作完成后,同步项目,问题解决


5.BuildTool最低版本异常
升级BuildTool版本异常.png

这个异常出现就显而易见了,AS3.0最低支持的BuildTools插件是26.0.2版本,别问我BuildTools是啥,我也不知道(顾名思义,AS的编译工具);BuildTools的版本改到26.0.2版本,同步代码就好了,如果你的SDK中没有下载BuildTools26.0.2版本,AS会自动的提示你去下载,下载完同步代码,即可;


6.BuildTool库项目版本不统一问题
BuildTool库项目版本不统一问题.png
AS3.0对于库项目的build.gradle的配置也进行了干预,官方说可以加快编译速度,想想也是,库项目都用不同版本的BuildTool,编译起来肯定慢;所以这里点击Open File之后,定位到的build.gradle文件,修改里面的buildToolsVersion节点为26.0.2即可

如果项目中的库项目较多,建议将buildToolsVersion版本配置到gradle.properties文件中,然后项目中的库项目都引用该配置,改一处,则整个项目的buildToolsVersion配置都改了,别问我咋配置的,因为这会跑题,自行百度


7.multidex版本异常

multidex版本异常.png

这个问题说的是AS3.0解析multidex1.0.2版本失败,为什么失败?

因为现在google自家的依赖,全部都收回到了自家的CDN服务器了,之前在项目级的build.gradle文件中的repositories节点中配置jenter(),就可以获取大部分的依赖(虽然慢了点),但是现在Google官方需要我们在repositories节点中配置上google(),作用就是获取自家的依赖,而原先的jcenter()不需要动;而multidex是Google的依赖所以只用之前的jcenter(),肯定是解析不到它了.
配置例如

repositories {
        google()//新增的
        jcenter()
}

项目级的build.gradle文件中的有两个repositories节点,都配置上google()

同步项目,问题KO


8.Lambda插件冲突

lambda插件冲突.png

Warning:One of the plugins you are using supports Java 8 language features. To try the support built into the Android plugin, remove the following from your build.gradle:
    apply plugin: 'me.tatarka.retrolambda'
To learn more, go to https://d.android.com/r/tools/java-8-support-message.html

这个不用多说相信大家在准备升级AS3.0都知道,它的一大特性是支持了JAVA8,而项目之前为了能用Lambda,而用了第三方的插件,这里移除即可;

移除步骤
1. 在项目级别的build.gradle也就是最外层的build.gradle文件中的dependencies节点中,移除

    classpath 'me.tatarka:gradle-retrolambda:3.2.0'//lambda表达式



2. 在应用级别的build.gradle的顶部移除

    apply plugin: 'me.tatarka.retrolambda'//lambda表达式

上面两步操作完成后,同步项目,问题解决


9.flavor配置异常
flavor配置异常.png

Error:All flavors must now belong to a named flavor dimension. Learn more at https://d.android.com/r/tools/flavorDimensions-missing-error-message.html

这个可以参考官方给出的文档地址(网络要绝对的通畅~)
问题出现在之前的flavor配置不能用了,别问我flavor是啥,你自己配置的你不知道~(主要作用,多渠道打包)

    //之前的配置
    productFlavors {
        _360 {}
       baidu {}
       xiaomi {}
       meizu {}
       tencent {}
    }
    productFlavors.all { flavor ->
        flavor.manifestPlaceholders = [CLICK_CHANNEL_VALUE: name]
    }
 //  ==============================分割线===================================   
    //改成如下配置,问题解决
    flavorDimensions "tier"//新增的,值是数组
    productFlavors {
         _360 { dimension "tier"}
        baidu { dimension "tier"}
        xiaomi { dimension "tier"}
        meizu { dimension "tier"}
        tencent { dimension "tier"}
    }

    productFlavors.all { flavor ->
        flavor.manifestPlaceholders = [CLICK_CHANNEL_VALUE: name]
    }

想知道为什么这样配置,可以看看官方文档


至此上述配置更改后,我的项目同步代码不报错了~,但是坑远远没有填完,继续


10.AAPT2编译异常
AAPT2版本异常.png
这一大串的异常在编译的时候报出,我在第一次导入项目的时候遇到了,第二次导入其它项目的时候,竟然没有遇到,对比之下得出问题是出在配置了高版本的support包的问题
,当你把项目所有support包的版本配置到25.2.0的时候什么问题都没有,但是配置成26.0.0或者27.0.0版本的时候就会出现这个问题(亲测);

解决方案
1. 使用低版本的support包,把项目所有support包的版本配置到25.2.0或者其它较低的版本
2. 配置gradle.properties中关闭AAPT2编译,说人话就是在其中增加android.enableAapt2=false配置,再次编译问题解决(推荐),例如

android.enableAapt2=false

同步代码,问题KO;


11.方法找不到异常/或者有点莫名其妙的异常
findViewById异常.png

androidSDK版本号异常.png

这两个异常产生的的原因是因为第九条如果你升级了support包的版本的时候compileSdkVersion的版本没有更改,亲测如果你的support包更改到了26.0.0或以上的话,需要更改项目中所有的compileSdkVersion为26或以上

compileSdkVersion = 26

更改好,同步代码,问题解决


到这我的项目可以运行,可以调试了,以为终于KO了所有问题了,但是但是编译输入release包的时候内存溢出了,WTF


12.生成release包异常
生成release包异常.png
看到这个异常我是一脸的蒙蔽,各种百度,google都没有说这个问题,咋滴,不让用啦,手动打包啊~,但是到夜里的时候忽然灵光一现,WTF,会不会是又是啥第三方依赖的问题,毕竟很多问题都是因为第三方的依赖,于是乎,连忙的注释了,一大堆的项目级别的build.gradle文件中的一些依赖,经过测试,定位到了美团的热更新,然后移除了,相关的配置,然后一些正常~~

移除步骤
1. 在项目级别的build.gradle也就是最外层的build.gradle文件中的dependencies节点中,移除

//美团热更新
classpath "com.meituan.robust:gradle-plugin:${ROBUST_VERSION}"
classpath "com.meituan.robust:auto-patch-plugin:${ROBUST_VERSION}"



2. 在应用级别的build.gradle的顶部移除

apply plugin: 'robust'//美团热更新框架



3. 在应用级别的build.gradle的dependencies节点中的

  //美团热更新框架
    compile "com.meituan.robust:robust:${ROBUST_VERSION}"

依赖可以不移除(不移除也是可以正常生成apk文件的,只是热更新无法使用),这个依赖如果移除了,那么你代码中相关的热更新代码也需要移除,否则就是找不到相关的类了;


** 最后的最后,AS3.0算是彻底的用上了,编译速度相比之前有没有增快,新特性好不好用,有待后续的使用了.
希望大家在升级AS3.0的时候如果遇到和我相同的问题,可以做一个参考 **

展开阅读全文

没有更多推荐了,返回首页